/* 1. Create a working list of Independent SFs which are tracked by running the following query in Query Builder*/
select sf.source_feature_id 
from source_feature sf, element_subnational est, d_eo_track_status ts 
where sf.independent_source_feature_ind='Y' 
and sf.element_subnational_id = est.element_subnational_id
and est.d_eo_track_status_id = ts.d_eo_track_status_id
and ts.eo_track_status_cd in ('Y','P','W')

/* 2. Go to the Source Feature Working List page and note the Working List ID*/
/* 3. Replace 1869 in the following queries with the appropriate Working List ID*/

/* 4. In Query Builder, run the following 3 queries,  to determine if there are point, line, and polygon SFs which need to be 
downloaded; if more than 0 records, will need to export to shapefile, using the subsequent queries*/
select count(pre_sf.source_feature_id)
from source_feature_pre_line pre_sf,  working_list_src_feat_data wl
where wl.data_id=pre_sf.source_feature_id
and wl.working_list_id=1869

select count(pre_sf.source_feature_id)
from source_feature_pre_poly pre_sf,  working_list_src_feat_data wl
where wl.data_id=pre_sf.source_feature_id
and wl.working_list_id=1869

select count(pre_sf.source_feature_id)
from source_feature_pre_pt pre_sf,  working_list_src_feat_data wl
where wl.data_id=pre_sf.source_feature_id
and wl.working_list_id=1869

/* 5. Run the following queries and export them as shapefiles, determined by the need identified by the queries above*/
select pre_sf.shape, sf.element_subnational_id est_id, sf.source_feature_id, cf.CONC_FEATURE_TYPE_DESC CONC_FEAT_, lut.LOC_UNCERTAINTY_TYPE_DESC loc_uncert, sf.LOC_UNCERTAINTY_DISTANCE distance, D_UNIT.UNIT_DESC DIST_UNIT, luc.location_use_class_desc, sf.element_subnational_id||' - '||luc.location_use_class_desc est_by_LUC
from source_feature_pre_line pre_sf, source_feature sf,D_CONC_FEATURE_TYPE cf, D_LOC_UNCERTAINTY_TYPE lut, D_UNIT, working_list_src_feat_data wl, d_location_use_class luc, D_EST_REP_ACCURACY ra
where 
sf.D_CONC_FEATURE_TYPE_ID=cf.D_CONC_FEATURE_TYPE_ID (+)
and sf.D_LOC_UNCERTAINTY_TYPE_ID=lut.D_LOC_UNCERTAINTY_TYPE_ID (+)
and sf.LOC_UNCERTAINTY_UNIT_ID=D_UNIT.D_UNIT_ID (+)
and sf.d_LOCATION_USE_CLASS_ID=luc.d_location_use_class_id (+)
AND sf.source_feature_id=pre_sf.source_feature_id
and wl.data_id=sf.source_feature_id
and sf.d_est_rep_accuracy_id=ra.d_est_rep_accuracy_id (+)
and wl.working_list_id=1869

select pre_sf.shape, sf.element_subnational_id est_id, sf.source_feature_id, cf.CONC_FEATURE_TYPE_DESC CONC_FEAT_, lut.LOC_UNCERTAINTY_TYPE_DESC loc_uncert, sf.LOC_UNCERTAINTY_DISTANCE distance, D_UNIT.UNIT_DESC DIST_UNIT, luc.location_use_class_desc, sf.element_subnational_id||' - '||luc.location_use_class_desc est_by_LUC
from source_feature_pre_poly pre_sf, source_feature sf, D_CONC_FEATURE_TYPE cf, D_LOC_UNCERTAINTY_TYPE lut, D_UNIT, working_list_src_feat_data wl, d_location_use_class luc, D_EST_REP_ACCURACY ra
where 
sf.D_CONC_FEATURE_TYPE_ID=cf.D_CONC_FEATURE_TYPE_ID (+)
and sf.D_LOC_UNCERTAINTY_TYPE_ID=lut.D_LOC_UNCERTAINTY_TYPE_ID (+)
and sf.LOC_UNCERTAINTY_UNIT_ID=D_UNIT.D_UNIT_ID (+)
and sf.d_LOCATION_USE_CLASS_ID=luc.d_location_use_class_id (+)
AND sf.source_feature_id=pre_sf.source_feature_id
and wl.data_id=sf.source_feature_id
and sf.d_est_rep_accuracy_id=ra.d_est_rep_accuracy_id (+)
and wl.working_list_id=1869

select pre_sf.shape, sf.element_subnational_id est_id, sf.source_feature_id, cf.CONC_FEATURE_TYPE_DESC CONC_FEAT_, lut.LOC_UNCERTAINTY_TYPE_DESC loc_uncert, sf.LOC_UNCERTAINTY_DISTANCE distance, D_UNIT.UNIT_DESC DIST_UNIT, luc.location_use_class_desc, sf.element_subnational_id||' - '||luc.location_use_class_desc est_by_LUC
from source_feature_pre_pt pre_sf, source_feature sf, working_list_src_feat_data wl, D_CONC_FEATURE_TYPE cf, D_LOC_UNCERTAINTY_TYPE lut, D_UNIT, d_location_use_class luc, D_EST_REP_ACCURACY ra
where
wl.data_id=pre_sf.source_feature_id 
AND sf.source_feature_id=pre_sf.source_feature_id
and sf.D_CONC_FEATURE_TYPE_ID=cf.D_CONC_FEATURE_TYPE_ID (+)
and sf.D_LOC_UNCERTAINTY_TYPE_ID=lut.D_LOC_UNCERTAINTY_TYPE_ID (+)
and sf.LOC_UNCERTAINTY_UNIT_ID=D_UNIT.D_UNIT_ID (+)
and sf.d_LOCATION_USE_CLASS_ID=luc.d_location_use_class_id (+)
and sf.d_est_rep_accuracy_id=ra.d_est_rep_accuracy_id (+)
and wl.working_list_id=1869


/* 6. In Query Builder, run the separation_distance.sql query and export to CSV. Rename the file to separation_distance.csv*/
/* 7. Unzip the downloaded shapefiles*/
/* 8. In ArcGIS Pro, run the "Prep Independent SFs for BLPT" tool
/* 9. As appropriate, update the SEP_DISTANCE field to the UNSUITABLE_HAB_SEP_DISTANCE value or a custom distance */
/* 10. Download the Biotics backups - if as individual shapefiles, create BioticsBackups.gdb and import as eo, source_line, source_poly, source_pt */
/* 11. Run the Bulk Load Prep Toolbox (BLPT) to create new or identify existing EOs, according to the separation distance analysis
/* 12. Once the BLPT has finished running, in ArcGIS Pro, run the "Prep Independent SFs for Bulk Replace in Biotics" tool
/* 13. Run the Bulk Replace tool in the Biotics Map using the Ind_SFs_easy.gdb. */
/* 21. After running the Bulk Replace, run the following query and export as an Excel file. */
select v.visit_id, v.source_feature_id, eo.eo_id, v.VISIT_DATE, v.VISITED_BY, v.DETECTED_IND, eo.FIRST_OBS_DATE, eo.LAST_OBS_DATE, eo.SURVEY_DATE, 
delimlist('SELECT distinct(s.surveyor) FROM eo_surveyor s,eo WHERE s.EO_ID = '||eo.eo_id,', ') as SURVEYOR
from visit v, eo_source_feature eosf, eo
where v.source_feature_id in (
select wl.data_id
from working_list_src_feat_data wl 
where wl.working_list_id = 29164)
and v.source_feature_id = eosf.source_feature_id
and eosf.eo_id = eo.eo_id

/* 22. In ArcGIS Pro, run the "Update EO Data based on Working List" tool
/* 23. Log into a third-party tool (SQLPlus, SQL Developer, Tora, Toad) as the biotics_dlink user to run the "update_EOs.sql" script generated by the "Update EO Data based on Working List" tool in ArcGIS Pro. */
/* 24. Manually review the records within Ind_SFS_hard.gdb as time allows & then run the Bulk Replace tool in the Biotics Map on the Ind_SFS_hard.gdb, repeating Steps 20 - 23   */